package AES;

import java.util.Random;
import AES.graphic.MainUI;

public class KeyUtils {
	
	private static final char[] HEX_DIGITS = {
		'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'
	};
	
	public static boolean testKey(String key, MainUI main_ui) {
		System.out.println("\nTeste Schlssel...");
		if(key.length() == 32 || key.length() == 48 || key.length() == 64) {
			for(int i = 0; i < key.length(); i++) {			
				switch(key.charAt(i)) {
				case '0': break;
				case '1': break;
				case '2': break;
				case '3': break;
				case '4': break;
				case '5': break;
				case '6': break;
				case '7': break;
				case '8': break;
				case '9': break;
				case 'A': break;
				case 'a': break;
				case 'B': break;
				case 'b': break;
				case 'C': break;
				case 'c': break;
				case 'D': break;
				case 'd': break;
				case 'E': break;
				case 'e': break;
				case 'F': break;
				case 'f': break;
				default: 
					System.out.println(" FEHLER\n");
					return false;
				}
			} return true;
		} 
		else {
			System.out.println(" FEHLER");
			return false;
		}
	}

	public static byte[] generateKey(int keysize) {
		byte[] key = new byte[keysize/8];
		
		int b;
		Random random = new Random();
		for(int i = 0; i < keysize / 8; i++) {
			b = random.nextInt(255);
			key[i] = (byte)(b & 0xFF);
		} return key;
	}
	
	/**
	 * Returns a string of hexadecimal digits from a byte array. Each
	 * byte is converted to 2 hex symbols.
	 */
	public static String keyToString(byte[] ba) {
		int length = ba.length;
		char[] buf = new char[length * 2];
		for (int i = 0, j = 0, k; i < length; ) {
			k = ba[i++];
			buf[j++] = HEX_DIGITS[(k >>> 4) & 0x0F];
			buf[j++] = HEX_DIGITS[ k        & 0x0F];
		}
		return new String(buf);
	}
	
	/**
	 * Konvertiert einen Schlssel von String nach byte.
	 * @param key_value Ein Schlssel im String-Format.
	 * @return Einen Schlssel im byte-Format.
	 * @throws Exception 
	 */
	public static byte[] readKey(String key_value) throws Exception {
		byte[] key = new byte[key_value.length()/2];
		
		for(int i = 0; i < key_value.length();) {
			byte b = 0;
			switch(key_value.charAt(i)) {
			case '0': b = (byte) (b | 0x00); break;
			case '1': b = (byte) (b | 0x10); break;
			case '2': b = (byte) (b | 0x20); break;
			case '3': b = (byte) (b | 0x30); break;
			case '4': b = (byte) (b | 0x40); break;
			case '5': b = (byte) (b | 0x50); break;
			case '6': b = (byte) (b | 0x60); break;
			case '7': b = (byte) (b | 0x70); break;
			case '8': b = (byte) (b | 0x80); break;
			case '9': b = (byte) (b | 0x90); break;
			case 'A': b = (byte) (b | 0xA0); break;
			case 'a': b = (byte) (b | 0xA0); break;
			case 'B': b = (byte) (b | 0xB0); break;
			case 'b': b = (byte) (b | 0xB0); break;
			case 'C': b = (byte) (b | 0xC0); break;
			case 'c': b = (byte) (b | 0xC0); break;
			case 'D': b = (byte) (b | 0xD0); break;
			case 'd': b = (byte) (b | 0xD0); break;
			case 'E': b = (byte) (b | 0xE0); break;
			case 'e': b = (byte) (b | 0xE0); break;
			case 'F': b = (byte) (b | 0xF0); break;
			case 'f': b = (byte) (b | 0xF0); break;
			default: throw new Exception("Fehlerhafter Schlssel");
			} i++;
			switch(key_value.charAt(i)) {
			case '0': b = (byte) (b | 0x00); break;
			case '1': b = (byte) (b | 0x01); break;
			case '2': b = (byte) (b | 0x02); break;
			case '3': b = (byte) (b | 0x03); break;
			case '4': b = (byte) (b | 0x04); break;
			case '5': b = (byte) (b | 0x05); break;
			case '6': b = (byte) (b | 0x06); break;
			case '7': b = (byte) (b | 0x07); break;
			case '8': b = (byte) (b | 0x08); break;
			case '9': b = (byte) (b | 0x09); break;
			case 'A': b = (byte) (b | 0x0A); break;
			case 'a': b = (byte) (b | 0x0A); break;
			case 'B': b = (byte) (b | 0x0B); break;
			case 'b': b = (byte) (b | 0x0B); break;
			case 'C': b = (byte) (b | 0x0C); break;
			case 'c': b = (byte) (b | 0x0C); break;
			case 'D': b = (byte) (b | 0x0D); break;
			case 'd': b = (byte) (b | 0x0D); break;
			case 'E': b = (byte) (b | 0x0E); break;
			case 'e': b = (byte) (b | 0x0E); break;
			case 'F': b = (byte) (b | 0x0F); break;
			case 'f': b = (byte) (b | 0x0F); break;
			default: throw new Exception("Fehlerhafter Schlssel");
			} i++;
			key[(i/2)-1] = b;
		}	
		return key;
	}
}
