package AES.graphic;

import java.awt.event.*;
import java.awt.*;

import javax.swing.*;

import Rijndael.Rijndael_Algorithm;

import java.io.*;
import java.security.InvalidKeyException;

import AES.KeyUtils;

public class MainUI extends JFrame implements ActionListener {

	/**
	 * SerialVersionUID. Wegen Interface Serializable!?
	 * Keine Ahnung wofr!
	 */
	private static final long serialVersionUID = 1L;
	
	private JTextArea key_text_area;
	private JTextArea message_text_area;
	private int keysize;
	private byte[] key;

    public MainUI() {
        super("AES-Verschlsselung");
        this.setDefaultCloseOperation(EXIT_ON_CLOSE);
        this.getContentPane().setLayout(new BorderLayout());
        this.setJMenuBar(AES_Menu.makeMenu(this));
        
        JPanel panel1 = new JPanel();
        panel1.setBorder(BorderFactory.createEtchedBorder());
        
        JLabel key_label = new JLabel("Schlssel: ");
        this.key_text_area = new JTextArea("Kein Schlssel erzeugt");
        this.key_text_area.setBorder(BorderFactory.createEtchedBorder());
        this.key_text_area.setFont(new Font("Verdana", 1, 11));
        this.key_text_area.setEditable(false);
        this.key_text_area.setColumns(58);
        
        this.message_text_area = new JTextArea();
        this.message_text_area.setBorder(BorderFactory.createEtchedBorder());
        this.message_text_area.setFont(new Font("Verdana", 1, 11));
        this.message_text_area.setEditable(false);
        
        panel1.add(key_label);
        panel1.add(this.key_text_area);
        this.getContentPane().add(panel1, BorderLayout.NORTH);
        this.getContentPane().add(new JScrollPane(this.message_text_area));
        
        PipedOutputStream pout = new PipedOutputStream();
        PrintStream psout = new PrintStream(pout, true);
        System.setOut(psout);
        System.setErr(psout);
        
        BufferedReader br1 = null;
        try { br1 = new BufferedReader(
        		new InputStreamReader(new PipedInputStream(pout))); }
        catch(IOException e) { e.printStackTrace(); }     
        Console console1 = new Console(this.message_text_area, br1);
       
        this.setSize(800, 800);
        this.setVisible(true);
        this.keysize = 128;
        
        console1.run();
    }

    
/** *********************************************************************** **/	
/** ******************* Ver - und Entschlsseln *************************** **/
/** *********************************************************************** **/
    private void checkFile(File old_file){
    	int add = 0;
    	long x = old_file.length() % 8;
    	String name = old_file.getAbsolutePath();
    	if(name.endsWith(".txt") && x != 0) {
    		if(x == 1) add = 7;
    		if(x == 2) add = 6;
    		if(x == 3) add = 5;
    		if(x == 4) add = 4;
    		if(x == 5) add = 3;
    		if(x == 6) add = 2;
    		if(x == 7) add = 1;
    		try{
    			BufferedWriter out = new BufferedWriter(
    					new OutputStreamWriter(new FileOutputStream(name, true)));
	    		for(int i=0; i<add; i++){ out.write(' '); }
	    		out.close();
    		} catch(IOException e) { e.printStackTrace(); }
    	}
    }
    
    private void encryptFile(File old_file, File new_file) {
    	checkFile(old_file);
    	BufferedInputStream fs_old;
    	BufferedOutputStream fs_new;
		try {
			fs_old = new BufferedInputStream(new FileInputStream(old_file));
			fs_new = new BufferedOutputStream(new FileOutputStream(new_file, true));
			System.out.println("\nBeginne Verschlsselung...");
			
			int reads = 0;
			byte[] input = new byte[Rijndael_Algorithm.blockSize()];
			while((reads = fs_old.read(input)) != -1) {
				for(int i = 0; i < Rijndael_Algorithm.blockSize(); i++) {
					System.out.print((char)input[i]);
				} System.out.println();
				System.out.println("Decrypt READS:"+reads);
				byte[] output = Rijndael_Algorithm.blockEncrypt(input, 0, 
						Rijndael_Algorithm.makeKey(this.key), reads);
				fs_new.write(output);
			}
			System.out.println("\n...Ende Verschlsselung");
			fs_old.close();
			fs_new.close();
		} 
		catch (FileNotFoundException e) { e.printStackTrace(); }
		catch(InvalidKeyException e) { e.printStackTrace(); }
		catch (IOException e) { e.printStackTrace(); }
    }
    
    private void decryptFile(File old_file, File new_file) {
    	BufferedInputStream fs_old; 
		BufferedOutputStream fs_new;	
		try {
			fs_old = new BufferedInputStream(new FileInputStream(old_file));
			fs_new = new BufferedOutputStream(new FileOutputStream(new_file, true));
			System.out.println("Beginne Entschlsselung...");
		
			int reads = 0;
			byte[] input = new byte[Rijndael_Algorithm.blockSize()];
			while((reads = fs_old.read(input)) != -1) {
				for(int i = 0; i < Rijndael_Algorithm.blockSize(); i++) {
					System.out.print((char)input[i]);
				} System.out.println();
				System.out.println("Decrypt READS:"+reads);
				byte[] output = Rijndael_Algorithm.blockDecrypt(input, 0, 
						Rijndael_Algorithm.makeKey(this.key), reads);
				fs_new.write(output);
			}
			System.out.println("...Ende Entschlsselung");
			fs_old.close();
			fs_new.close();
		} 
		catch (FileNotFoundException e) { e.printStackTrace(); }
		catch(InvalidKeyException e) { e.printStackTrace(); }
		catch (IOException e) { e.printStackTrace(); }
    }
    

/** *********************************************************************** **/	
/** ************************ ActionListener ******************************* **/
/** *********************************************************************** **/	
	public void actionPerformed(ActionEvent e) {
		
		// Verschlsseln von Daten
		if(e.getActionCommand().equalsIgnoreCase("Verschlsseln")) {
			JFileChooser chooser = new JFileChooser();			
			if(chooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {				
				try {
					String eingabe = chooser.getSelectedFile().getAbsolutePath();
					File old_file = new File(eingabe);
					File new_file = new File(eingabe+".AES");
					
					if(old_file.isFile()) {
						if(new_file.isFile()) {
							int choice = JOptionPane.showConfirmDialog(this, 
								"Ziel Datei "+new_file.getName()+" bereits vorhanden",
								"Verschlsseln", JOptionPane.YES_NO_OPTION);
							if(choice == 0) {
								new_file.delete();
								encryptFile(old_file, new_file);
							}
						} else { encryptFile(old_file, new_file); }
					} 
					else {
						JOptionPane.showMessageDialog(this, 
								"Bitte whlen Sie eine Datei, kein Verzeichnis",
								"Entschlsseln", JOptionPane.INFORMATION_MESSAGE);
					}
					this.getContentPane().repaint();
				} catch(Exception ex) { ex.printStackTrace(); }		
			}
		}
		
		// Enschlsseln von Daten
		if(e.getActionCommand().equalsIgnoreCase("Entschlsseln")) {
			JFileChooser chooser = new JFileChooser();			
			if(chooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {				
				try {				
					String eingabe = chooser.getSelectedFile().getAbsolutePath();
					
					File old_file = new File(eingabe);
					File new_file = new File(eingabe.substring(0, eingabe.length() - 4));
					
					if(old_file.isFile()) {
						if(new_file.isFile()) {
							int choice = JOptionPane.showConfirmDialog(this, 
									"Ziel Datei "+new_file.getName()+" bereits vorhanden",
									"Entschlsseln", JOptionPane.YES_NO_OPTION);
							if(choice == 0) {
								new_file.delete();
								decryptFile(old_file, new_file);
							}
						} else { decryptFile(old_file, new_file); }
					}
					else {
						JOptionPane.showMessageDialog(this, 
								"Bitte whlen Sie eine Datei, kein Verzeichnis",
								"Entschlsseln", JOptionPane.INFORMATION_MESSAGE);
					}
					this.getContentPane().repaint();
				} catch(Exception ex) { ex.printStackTrace(); }		
			}
		}
		
		// Schlssel Erzeugung
		if(e.getActionCommand().equalsIgnoreCase("Erzeugen")) {
			this.key = KeyUtils.generateKey(keysize);
			this.key_text_area.setText(KeyUtils.keyToString(this.key));
		}
		
		// Einstellung von Schlsselgre
		if(e.getActionCommand().equalsIgnoreCase("Lnge")) {
			Object[] possibilities = { "128", "192", "256" };
			String choice = (String) JOptionPane.showInputDialog(this,
					"Bitte Schlssellnge whlen", "Schlssellnge",
					JOptionPane.QUESTION_MESSAGE, null,	possibilities, "128");
			if(choice != null) { this.keysize = Integer.parseInt(choice); }
		}
		
		// ffnen eines gespeicherten Schlssels
		if(e.getActionCommand().equalsIgnoreCase("ffnen")) {
			JFileChooser chooser = new JFileChooser();			
			if(chooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {				
				try {				
					String eingabe = chooser.getSelectedFile().getAbsolutePath();
					BufferedReader b = new BufferedReader(new FileReader(eingabe));
					String key_string = b.readLine();
					
					if(KeyUtils.testKey(key_string, this)) {
						this.keysize = key_string.length() * 4;
						this.key = KeyUtils.readKey(key_string);
						this.key_text_area.setText(KeyUtils.keyToString(this.key));
					} else { this.key_text_area.setText("Fehlerhafte Schlssellnge"); }
					b.close();
				} catch(Exception ex) { ex.printStackTrace(); }		
			}
		}
		
		// Speichern eines generierten Schlssels
		if(e.getActionCommand().equalsIgnoreCase("Speichern")) {
			JFileChooser chooser = new JFileChooser();			
			if(chooser.showSaveDialog(this) == JFileChooser.APPROVE_OPTION) {				
				try {
					if(KeyUtils.testKey(KeyUtils.keyToString(this.key), this)) {
						String eingabe = chooser.getSelectedFile().getAbsolutePath();
						File new_key = new File(eingabe);
						
						if(!new_key.isDirectory()) {
							if(new_key.isFile()) {
								int choice = JOptionPane.showConfirmDialog(this, 
										"Ziel Datei "+new_key.getName()+" bereits vorhanden",
										"Verschlsseln", JOptionPane.YES_NO_OPTION);
								if(choice == 0) {
									BufferedWriter b = new BufferedWriter(new FileWriter(eingabe));
									System.out.println(KeyUtils.keyToString(this.key));
									b.write(KeyUtils.keyToString(this.key));
									b.close();
								}
							} 
							else {
								BufferedWriter b = new BufferedWriter(new FileWriter(eingabe));
								System.out.println(KeyUtils.keyToString(this.key));
								b.write(KeyUtils.keyToString(this.key));
								b.close();
							}
						} 
						else {
							JOptionPane.showMessageDialog(this, 
									"Bitte whlen Sie eine Datei, kein Verzeichnis",
									"Entschlsseln", JOptionPane.INFORMATION_MESSAGE);
						}
					}
				} catch(Exception ex) { ex.printStackTrace(); }		
			}
		}
	}
}
	