public class SBoxTest {
		static final int[] alog = new int[256];
		static final int[] log =  new int[256];
		static final byte[] S =  new byte[256];
		static final byte[] Si = new byte[256];

	public static void main(String[] args) {
		int ROOT = 0x11B;
		int i, j = 0;

		alog[0] = 1;
		for (i = 1; i < 256; i++) {
			j = (alog[i-1] << 1) ^ alog[i-1];
			//System.out.println("alog[i-1]:"+alog[i-1]+" j=((alog[i-1] << 1) ^ alog[i-1]):"+j);
			if ((j & 0x100) != 0) j ^= ROOT;
			//System.out.println("((j & 0x100) != 0) j ^= m(x):"+j); 
			alog[i] = j;
        }

		// Testausgabe
		for(i = 0; i < alog.length; i++) {
			System.out.print(alog[i]+" ");
		} System.out.println();

		for (i = 1; i < 255; i++) log[alog[i]] = i;

		// Testausgabe
		for(i = 0; i < log.length; i++) {
			System.out.print(log[i]+" ");
		} System.out.println();

        byte[][] A = new byte[][] {
            {1, 1, 1, 1, 1, 0, 0, 0},
            {0, 1, 1, 1, 1, 1, 0, 0},
		    {0, 0, 1, 1, 1, 1, 1, 0},
		    {0, 0, 0, 1, 1, 1, 1, 1},
		    {1, 0, 0, 0, 1, 1, 1, 1},
		    {1, 1, 0, 0, 0, 1, 1, 1},
		    {1, 1, 1, 0, 0, 0, 1, 1},
		    {1, 1, 1, 1, 0, 0, 0, 1}
		};
        byte[] B = new byte[] { 0, 1, 1, 0, 0, 0, 1, 1};

        //
        // substitution box based on F^{-1}(x)
        //
        int t;
        byte[][] box = new byte[256][8];
        box[1][7] = 1;
        for (i = 2; i < 256; i++) {
            j = alog[255 - log[i]];
            for (t = 0; t < 8; t++)
                box[i][t] = (byte)((j >>> (7 - t)) & 0x01);
        }
        //
        // affine transform:  box[i] <- B + A*box[i]
        //
        byte[][] cox = new byte[256][8];
        for (i = 0; i < 256; i++)
            for (t = 0; t < 8; t++) {
                cox[i][t] = B[t];
                for (j = 0; j < 8; j++)
                    cox[i][t] ^= A[t][j] * box[i][j];
            }
        //
        // S-boxes and inverse S-boxes
        //
        for (i = 0; i < 256; i++) {
            S[i] = (byte)(cox[i][0] << 7);
	        for (t = 1; t < 8; t++)
	            S[i] ^= cox[i][t] << (7-t);
            Si[S[i] & 0xFF] = (byte) i;
        }

		final byte[] rcon = new byte[30];
		rcon[0] = 1;
		int r = 1;
		for (t = 1; t < 30; ) rcon[t++] = (byte)(r = mul(2, r));

		// Testausgabe
		for(t = 0; t < 30; t++) {
			System.out.println("rcon["+t+"]:"+(int)rcon[t]);
		}
	}

	// multiply two elements of GF(2^m)
	static final int mul (int a, int b) {
		return (a != 0 && b != 0) ?
		alog[(log[a & 0xFF] + log[b & 0xFF]) % 255] : 0;
    }
}